pub mod compiler;
pub mod error;
pub mod lexer;
pub mod parser;
pub mod token;

use compiler::Query;
use error::ElasticError;

pub fn compile(input: &str) -> Result<Query, ElasticError> {
    let tokens = lexer::scan(&input)?;
    let select = parser::parse(tokens)?;
    compiler::compile(select)
}
